org.apache.fop.area

## Class AreaTreeObject

- java.lang.Object
- - org.apache.fop.area.AreaTreeObject

- All Implemented Interfaces:
    java.lang.Cloneable
  Direct Known Subclasses:
    Area, Page, PageSequence, PageViewport

      public abstract class AreaTreeObject
      extends java.lang.Object
      implements java.lang.Cloneable

  Abstract base class for all area tree objects.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.List<ExtensionAttachment>` | `extensionAttachments` Extension attachments
    `protected java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String>` | `foreignAttributes` Foreign attributes

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AreaTreeObject()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addExtensionAttachment(ExtensionAttachment attachment)` Adds a new ExtensionAttachment instance to this page.
    `java.lang.Object` | `clone()`
    `java.util.List<ExtensionAttachment>` | `getExtensionAttachments()`
    `java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String>` | `getForeignAttributes()`
    `java.lang.String` | `getForeignAttributeValue(org.apache.xmlgraphics.util.QName name)` Returns the value of a foreign attribute on the area.
    `boolean` | `hasExtensionAttachments()` Indicates whether this area tree object has any extension attachments.
    `void` | `setExtensionAttachments(java.util.List<ExtensionAttachment> extensionAttachments)` Set extension attachments from a List
    `void` | `setForeignAttribute(org.apache.xmlgraphics.util.QName name, java.lang.String value)` Sets a foreign attribute.
    `void` | `setForeignAttributes(java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String> atts)` Add foreign attributes from a Map.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### foreignAttributes

          protected java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String> foreignAttributes

      Foreign attributes

    - #### extensionAttachments

          protected java.util.List<ExtensionAttachment> extensionAttachments

      Extension attachments

  - ### Constructor Detail

    - #### AreaTreeObject

          public AreaTreeObject()

  - ### Method Detail

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      Overrides:
        `clone` in class `java.lang.Object`
      Throws:
        `java.lang.CloneNotSupportedException`

    - #### setForeignAttribute

          public void setForeignAttribute(org.apache.xmlgraphics.util.QName name,
                                          java.lang.String value)

      Sets a foreign attribute.
      Parameters:
        `name` - the qualified name of the attribute
        `value` - the attribute value

    - #### setForeignAttributes

          public void setForeignAttributes(java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String> atts)

      Add foreign attributes from a Map.
      Parameters:
        `atts` - a Map with attributes (keys: QName, values: String)

    - #### getForeignAttributeValue

          public java.lang.String getForeignAttributeValue(org.apache.xmlgraphics.util.QName name)

      Returns the value of a foreign attribute on the area.
      Parameters:
        `name` - the qualified name of the attribute
      Returns:
        the attribute value or null if it isn't set

    - #### getForeignAttributes

          public java.util.Map<org.apache.xmlgraphics.util.QName,java.lang.String> getForeignAttributes()

      Returns:
        the foreign attributes associated with this area

    - #### addExtensionAttachment

          public void addExtensionAttachment(ExtensionAttachment attachment)

      Adds a new ExtensionAttachment instance to this page.
      Parameters:
        `attachment` - the ExtensionAttachment

    - #### setExtensionAttachments

          public void setExtensionAttachments(java.util.List<ExtensionAttachment> extensionAttachments)

      Set extension attachments from a List
      Parameters:
        `extensionAttachments` - a List with extension attachments

    - #### getExtensionAttachments

          public java.util.List<ExtensionAttachment> getExtensionAttachments()

      Returns:
        the extension attachments associated with this area

    - #### hasExtensionAttachments

          public boolean hasExtensionAttachments()

      Indicates whether this area tree object has any extension attachments.
      Returns:
        true if there are extension attachments

Copyright 1999-2020 The Apache Software Foundation. All Rights Reserved.